<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  Hero,
  BySolutionHeader,
  SolutionGrid,
  ByCompanySizeBlock,
  ByIndustryHeader,
  ByIndustryShowcase,
} from '../../components/solutions/landing/index.vue';
import GroupButtons from '~/components/common/group-buttons.vue';
import { getPageMetadata } from '~/common/meta';
import { PartnersGridFull } from '~/components/open-source/index.vue';
import { NextStep } from '~/components/common/index.vue';
import { BadgeTabs } from '~/components/home/index.vue';
import { getClient } from '~/plugins/contentful';

export default Vue.extend({
  components: {
    Hero,
    BySolutionHeader,
    SolutionGrid,
    NextStep,
    ByCompanySizeBlock,
    ByIndustryHeader,
    ByIndustryShowcase,
    PartnersGridFull,
    BadgeTabs,
    GroupButtons,
  },
  // eslint-disable-next-line
  nuxtI18n: false,
  async asyncData({ $content, error }: any) {
    try {
      const solutions = await $content(`solutions/index`).fetch();

      const entriesFromContentful = await getClient().getEntries({
        'sys.id': '74IkTNg7QIvXWHQBUUvi7m',
        include: 2,
      });

      const logoData = entriesFromContentful.items[0].fields;

      const logoAssets = logoData.logo.map((singleLogoData, index) => {
        const { fields: logoFields } = singleLogoData;

        const logoUrl = logoFields.image.fields.file.url;

        return {
          logo: logoUrl,
          alt: logoFields.altText,
          href: logoData.link[index].replace('https://about.gitlab.com/', '/'),
        };
      });

      solutions.by_industry.logos.partners = logoAssets;

      return { solutions };
    } catch (e) {
      console.error(e);
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).solutions, this.$route.path);
  },
});
</script>

<template>
  <div>
    <Hero v-bind="solutions.hero" />
    <GroupButtons class="desktop-only" :data="solutions.navigation" />
    <SlpContainer>
      <div id="by-solution">
        <BySolutionHeader v-bind="solutions.by_solution.hero" />
        <SolutionGrid v-bind="solutions.by_solution.grid" />
      </div>
      <div id="by-company-size">
        <ByCompanySizeBlock v-bind="solutions.by_company_size" />
      </div>
    </SlpContainer>
    <div id="by-industry">
      <SlpContainer variant="light-purple-100">
        <ByIndustryHeader v-bind="solutions.by_industry.hero" />
        <ByIndustryShowcase v-bind="solutions.by_industry.showcase" />
      </SlpContainer>
      <PartnersGridFull class="slp-pb-48" :data="solutions.by_industry.logos" />
    </div>
    <SlpContainer>
      <BadgeTabs :data="solutions.badges" />
    </SlpContainer>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.desktop-only {
  @media (max-width: $breakpoint-lg) {
    display: none;
  }
}
</style>
